<?php

namespace app\components;

use Yii;
use yii\base\Component;
use yii\base\InvalidConfigException;
use PDO;
use yii\web\Cookie;
use yii\web\Session;
use app\services\SsoUserTokenService;
use app\services\SsoUserRoleService;
use app\models\MailHistory;

class Utility extends Component
{

	public static function pushSMS($mobile, $content) {
		if (is_numeric($mobile) && !empty($content)) {
           $return['222'] = "NO_API_ENDPOINT";
       	}
       	else {
			$return['111'] = "INVALID_PARAMETERS";
       	}
		return $return;
  	}



    static function isSuperAdmin(){
        if(Yii::$app->user->identity->role != 'admin'){
            return false;
        } else {
            return true;
        }

    }

    static function isHelpDeskUser(){
        if(Yii::$app->user->identity->role != 'helpdesk'){
            return false;
        } else {
            return true;
        }

    }

	//@TODO
	 static function isValidToken($token)
	{
		$service = new SsoUserTokenService();
		$response = $service->isTokenActive($token);
		if ($response === true) {
			return true;
		} else {
			//return false;
			return true;
		}
	}

	//@TODO
	 static function getRBAC($token)
    {
    		$service = new SsoUserTokenService();
    		$uuid = $service->getUuidByToken($token);
    		if($uuid === FALSE) {
    			$res = "";
    			return $res;
    		} else {
    	    		$service = new SsoUserRoleService();
        			$response = $service->getUserRoleByUid($uuid);
        			return $response;
    		}
		//return array("TODO");
    }

	//@TODO
	 static function logError($class,$method,$model,$token,$message)
    {
		//echo "<pre>"; print_r(func_get_args()); exit;
		return array("TODO");
    }

	static function logException($class,$method,$model,$token,$message)
    {
		return array("TODO");
    }

    /**
    *Function to create sha1 to match hmac
    *@param String $string
    *@return String
    */
    static function saveInMailHistory($userName, $email, $subject, $content,$mailType, $registrationNumber="",$user_uuid){
        //$subject = "Link to reset your Password";
        if(!empty($email)) {
            $mailHistory = new MailHistory();
            $params = array();
            $params['mail_history_uuid'] = Yii::$app->utility->generateGuuid();
            $params['user_uuid'] = $user_uuid;
            $params['mail_receiver_email'] = $email;
            $params['mail_subject'] = $subject;
            $params['mail_message'] = $content;
            $params['mail_type'] = $mailType;
            $mailHistory->attributes = $params;
            if ($mailHistory->validate()) {
                $mailHistory->save();
                return TRUE;
            } else {
                $errors = $mailHistory->errors;
                echo "<pre>"; print_r($errors); die;
                return FALSE;
            }
        }
  }
  function sendMail($to,$link,$subject='Forgot Password'){
    if(!empty($to)) {
        Yii::$app->mailer->compose()
        ->setFrom('from@domain.com')
        ->setTo($to)
        ->setSubject($subject)
        ->setHtmlBody($link)
        ->send(); 
    }
   }
    static function generateSha1($string)
    {
        $hmac = sha1($string);
        return $hmac;
    }

    /**
    *Function to check JSON is valid or not
    *@param String $jsonStr [JSON data]
    *@return Boolean [true, false]
    */
    static function isValidJson($jsonStr)
    {
        json_decode($jsonStr);
        if (json_last_error() === JSON_ERROR_NONE) {
            return true;
        } else {
            return false;
        }
    }

    /**
    *Function to generate password salt
    *@param String $password
    *@return Boolean [true, false]
    */
    static function generatePasswordSalt()
    {
        $rand = rand(111, 99999).time();
        $dateTime = date("Y-m-d H:i:s");
        $salt = md5($rand.$dateTime);
        return $salt;
    }

    /**
    *Function to generater unique token for SSO
    *@param String $UUID [Unique GUID generated for each user
    *@return String $token  [40 chars sha1 hash as SSO Token]
    */
    static function generaterUniqueToken($email)
    {
        $time = time();
        $randValue = Yii::$app->utility->randomKey(8);
        $sha1 = sha1($time.$randValue.$email);
        return $sha1;
    }

    /**
    *Function to generater random number
    *@param String $length [random number Length]
    *@return String $key
    */

    private function randomKey($length) {
        $pool = array_merge(range(0,9), range('a', 'z'),range('A', 'Z'));
        for($i=0; $i < $length; $i++) {
            $key .= $pool[mt_rand(0, count($pool) - 1)];
        }
        return $key;
    }

    /**
    *Function to generater unique token for SSO
    *@return String $uuid
    */
    static function generateGuuid($moduleName, $tableName)
    {
       $time = time();
       $randValue = rand(10000000,99999999);
       /*       
       $firstmd5 = md5($time.$randValue);

       $time = time();
       $randValue = rand(10000000,99999999);
       $secondmd5 = md5($moduleName.$tableName.$randValue);

       $guuid = $firstmd5.$secondmd5;
       return ucwords($guuid);
       */
       
       return md5($moduleName.$tableName.$time.$randValue);
    }

    /**
	 * Function to sanatize a sting
	 * @param string $parameter
	 * @param boolean $strip_tags
	 * @return string
	 */
	static function sanatizeParams($parameter, $strip_tags = true) {
		if (is_array($parameter)) {
			$results = array();
			foreach ($parameter as $key => $value) {
                if (is_array($parameter)) {
                    foreach ($value as $v => $k) {
                        $v = trim($v);
                        if ($strip_tags) {
                            $v = strip_tags($v);
                        }
                        $v = Yii::$app->utility->mysql_escape_string($v);
                        $results[$key][$k] = $v;
                    }
                } else {
                    $value = trim($value);
                    if ($strip_tags) {
                        $value = strip_tags($value);
                    }
                    $value = Yii::$app->utility->mysql_escape_string($value);
                    $results[$key] = $value;
                }
			}
			return $results;
		} else {
			$parameter = trim($parameter);
			if ($strip_tags) {
				$parameter = strip_tags($parameter);
			}
			$parameter = Yii::$app->utility->mysql_escape_string($parameter);
			return $parameter;
		}
	}

	/**
	 * Function to escape the string
	 *
	 * @param string $string
	 * @return string
	 */
	static function mysql_escape_string($string) {
		$link = mysqli_connect(DB_SERVER, DB_USER, DB_PASS, DB_NAME);
		$string = mysqli_real_escape_string($link, $string);
		mysqli_close($link);
		return $string;
	}
	
	static function auditlog($sso_uuid,$table_unique_key,$token,$role_id,$module_uuid,$model_name,$new_row,$old_row){
        $url= REPORT_URL."/v1/auditlog/create"; 
           
        $params=array();
        $params['sso_uuid']=$sso_uuid;
        $params['table_unique_key']=$table_unique_key;
        $params['token']=$token;
        $params['role_id']=$role_id;
        $params['module_uuid']=$module_uuid;
        $params['model_name']=$model_name;
        $params['new_row']=$new_row;
		$params['old_row']=$old_row;
        $params['ip_address']=$_SERVER['REMOTE_ADDR'];
        $params['user_agent']=$_SERVER['HTTP_USER_AGENT'];
        
        //echo "<pre>"; print_r($params);exit;
        
        $response = Utility::postViaCurl($url, $params);
        return $response;
    }
	
	 public static function postViaCurl($url, $params, $curl_timeout = 10) {
        
        $token = $params['token'];
        
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
        curl_setopt($ch, CURLOPT_TIMEOUT, $curl_timeout);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $headers = [
            'token: ' . $token
        ];
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $server_output = curl_exec($ch);

        curl_close($ch);

        //var_dump($server_output);
  
        $server_output = json_decode($server_output, true);

        return $server_output['response'];
    }

	public function checkaadhaar($aadhar_number){
		
		$connection = Yii::$app->db;
		$year =date('Y');
		$query="SELECT * FROM  `sso_user_information` WHERE `aadhar_number` =:aadhar_number AND registration_year='$year' AND user_is_deleted='NO'" ;
        $command = $connection->createCommand($query);
        $command->bindValue(':aadhar_number', $aadhar_number);
        $sqlresponse=$command->queryOne();
		return $sqlresponse;
    }
    

    static function checkUGapplicationexist($applicant_info_uuid){
	 
        $connection = Yii::$app->db;	
        $sql = "select course_section_id , coursemode from applicant_application_course_choice ac
        inner join dhe_legacy_collegecourse cc on cc.collegecourseid = ac.college_course_id
        inner join dhe_legacy_course dc on dc.courseid = cc.courseid
        where applicant_application_uuid=:applicant_application_uuid
        and application_course_choice_status='ACTIVE'
        and application_course_choice_is_deleted='NO'";
        $command = $connection->createCommand($sql);
        $command->bindValue(':applicant_application_uuid', $applicant_info_uuid);
        $data = $command->queryAll();
    
        $coursemodecollection = array_column($data , 'coursemode'); // get all the course mode
        
    
        if( in_array( UG_ID , $coursemodecollection) &&  UG_CLOSED===TRUE ){  
    
            $flag = true; // applied for ug course , even if a single application found active
    
        }else{                         
    
            $flag = false;
    
        }
    
        return $flag;
    
         
    }
	
	

}
