<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "join_area_master".
 *
 * @property int $join_area_master_id
 * @property string $join_area_master_uuid
 * @property string $join_area_master_label
 * @property string $join_area_master_desc
 * @property string $join_area_master_created_date
 * @property string $join_area_master_modified_date
 * @property string $join_area_master_status
 * @property string $join_area_master_is_deleted
 *
 * @property JoinClub[] $joinClubs
 * @property JoinClubEvent[] $joinClubEvents
 * @property JoinSignup[] $joinSignups
 * @property JoinUserDetail[] $joinUserDetails
 */
class JoinAreaMaster extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'join_area_master';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['join_area_master_uuid', 'join_area_master_label'], 'required'],
            [['join_area_master_desc', 'join_area_master_status', 'join_area_master_is_deleted'], 'string'],
            [['join_area_master_created_date', 'join_area_master_modified_date'], 'safe'],
            [['join_area_master_uuid'], 'string', 'max' => 62],
            [['join_area_master_label'], 'string', 'max' => 512],
            [['join_area_master_uuid'], 'unique'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'join_area_master_id' => Yii::t('app', 'Join Area Master ID'),
            'join_area_master_uuid' => Yii::t('app', 'Join Area Master Uuid'),
            'join_area_master_label' => Yii::t('app', 'Join Area Master Label'),
            'join_area_master_desc' => Yii::t('app', 'Join Area Master Desc'),
            'join_area_master_created_date' => Yii::t('app', 'Join Area Master Created Date'),
            'join_area_master_modified_date' => Yii::t('app', 'Join Area Master Modified Date'),
            'join_area_master_status' => Yii::t('app', 'Join Area Master Status'),
            'join_area_master_is_deleted' => Yii::t('app', 'Join Area Master Is Deleted'),
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getJoinClubs()
    {
        return $this->hasMany(JoinClub::className(), ['join_area_master_uuid' => 'join_area_master_uuid']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getJoinClubEvents()
    {
        return $this->hasMany(JoinClubEvent::className(), ['join_club_event_area' => 'join_area_master_uuid']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getJoinSignups()
    {
        return $this->hasMany(JoinSignup::className(), ['join_area_master_uuid' => 'join_area_master_uuid']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getJoinUserDetails()
    {
        return $this->hasMany(JoinUserDetail::className(), ['join_area_master_uuid' => 'join_area_master_uuid']);
    }

    /**
     * {@inheritdoc}
     * @return JoinAreaMasterQuery the active query used by this AR class.
     */
    public static function find()
    {
        return new JoinAreaMasterQuery(get_called_class());
    }
}
