<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "join_audit_log".
 *
 * @property int $join_audit_role_log_id
 * @property string $join_audit_uuid
 * @property string $join_signup_uuid
 * @property string $join_token
 * @property string $join_signup_role
 * @property string $join_module_name
 * @property string $join_new_row
 * @property string $join_old_row
 * @property string $join_audit_ip_address
 * @property string $join_audit_user_agent
 * @property string $join_audit_modified_date
 * @property string $join_audit_log_created_date
 * @property string $join_audit_log_status
 * @property string $join_audit_log_is_deleted
 */
class JoinAuditLog extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'join_audit_log';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['join_audit_uuid', 'join_signup_uuid', 'join_signup_role', 'join_module_name', 'join_new_row', 'join_audit_ip_address', 'join_audit_user_agent'], 'required'],
            [['join_new_row', 'join_old_row', 'join_audit_log_status', 'join_audit_log_is_deleted'], 'string'],
            [['join_audit_modified_date', 'join_audit_log_created_date'], 'safe'],
            [['join_audit_uuid', 'join_signup_uuid', 'join_signup_role', 'join_audit_ip_address'], 'string', 'max' => 64],
            [['join_token'], 'string', 'max' => 32],
            [['join_module_name', 'join_audit_user_agent'], 'string', 'max' => 512],
            [['join_audit_uuid'], 'unique'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'join_audit_role_log_id' => Yii::t('app', 'Join Audit Role Log ID'),
            'join_audit_uuid' => Yii::t('app', 'Join Audit Uuid'),
            'join_signup_uuid' => Yii::t('app', 'Join Signup Uuid'),
            'join_token' => Yii::t('app', 'Join Token'),
            'join_signup_role' => Yii::t('app', 'Join Signup Role'),
            'join_module_name' => Yii::t('app', 'Join Module Name'),
            'join_new_row' => Yii::t('app', 'Join New Row'),
            'join_old_row' => Yii::t('app', 'Join Old Row'),
            'join_audit_ip_address' => Yii::t('app', 'Join Audit Ip Address'),
            'join_audit_user_agent' => Yii::t('app', 'Join Audit User Agent'),
            'join_audit_modified_date' => Yii::t('app', 'Join Audit Modified Date'),
            'join_audit_log_created_date' => Yii::t('app', 'Join Audit Log Created Date'),
            'join_audit_log_status' => Yii::t('app', 'Join Audit Log Status'),
            'join_audit_log_is_deleted' => Yii::t('app', 'Join Audit Log Is Deleted'),
        ];
    }

    /**
     * {@inheritdoc}
     * @return JoinAuditLogQuery the active query used by this AR class.
     */
    public static function find()
    {
        return new JoinAuditLogQuery(get_called_class());
    }
}
