<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "join_club_activity".
 *
 * @property int $join_club_activity_id
 * @property string $join_club_activity_uuid
 * @property string $join_club_activity_name
 * @property string $join_club_activity_detail
 * @property string $join_club_activity_created_date
 * @property string $join_club_activity_modified_date
 * @property string $join_club_activity_status
 * @property string $join_club_activity_is_deleted
 *
 * @property JoinClubActivityMapping[] $joinClubActivityMappings
 * @property JoinClubEvent[] $joinClubEvents
 */
class JoinClubActivity extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'join_club_activity';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['join_club_activity_uuid', 'join_club_activity_name', 'join_club_activity_detail'], 'required'],
            [['join_club_activity_detail', 'join_club_activity_status', 'join_club_activity_is_deleted'], 'string'],
            [['join_club_activity_created_date', 'join_club_activity_modified_date'], 'safe'],
            [['join_club_activity_uuid'], 'string', 'max' => 64],
            [['join_club_activity_name'], 'string', 'max' => 512],
            [['join_club_activity_uuid'], 'unique'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'join_club_activity_id' => Yii::t('app', 'Join Club Activity ID'),
            'join_club_activity_uuid' => Yii::t('app', 'Join Club Activity Uuid'),
            'join_club_activity_name' => Yii::t('app', 'Join Club Activity Name'),
            'join_club_activity_detail' => Yii::t('app', 'Join Club Activity Detail'),
            'join_club_activity_created_date' => Yii::t('app', 'Join Club Activity Created Date'),
            'join_club_activity_modified_date' => Yii::t('app', 'Join Club Activity Modified Date'),
            'join_club_activity_status' => Yii::t('app', 'Join Club Activity Status'),
            'join_club_activity_is_deleted' => Yii::t('app', 'Join Club Activity Is Deleted'),
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getJoinClubActivityMappings()
    {
        return $this->hasMany(JoinClubActivityMapping::className(), ['join_club_activity_uuid' => 'join_club_activity_uuid']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getJoinClubEvents()
    {
        return $this->hasMany(JoinClubEvent::className(), ['join_club_activity_uuid' => 'join_club_activity_uuid']);
    }

    /**
     * {@inheritdoc}
     * @return JoinClubActivityQuery the active query used by this AR class.
     */
    public static function find()
    {
        return new JoinClubActivityQuery(get_called_class());
    }
}
