<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "join_club_activity_mapping".
 *
 * @property int $join_club_activity_mapping_id
 * @property string $join_club_activity_mapping_uuid
 * @property string $join_club_activity_uuid
 * @property string $join_club_uuid
 * @property string $join_club_activity_mapping_created_date
 * @property string $join_club_activity_mapping_modified_date
 * @property string $join_club_activity_mapping_status
 * @property string $join_club_activity_mapping_is_deleted
 *
 * @property JoinClub $joinClubUu
 * @property JoinClubActivity $joinClubActivityUu
 */
class JoinClubActivityMapping extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'join_club_activity_mapping';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['join_club_activity_mapping_uuid', 'join_club_activity_uuid', 'join_club_uuid'], 'required'],
            [['join_club_activity_mapping_created_date', 'join_club_activity_mapping_modified_date'], 'safe'],
            [['join_club_activity_mapping_status', 'join_club_activity_mapping_is_deleted'], 'string'],
            [['join_club_activity_mapping_uuid', 'join_club_activity_uuid', 'join_club_uuid'], 'string', 'max' => 64],
            [['join_club_activity_mapping_uuid'], 'unique'],
            [['join_club_uuid'], 'exist', 'skipOnError' => true, 'targetClass' => JoinClub::className(), 'targetAttribute' => ['join_club_uuid' => 'join_club_uuid']],
            [['join_club_activity_uuid'], 'exist', 'skipOnError' => true, 'targetClass' => JoinClubActivity::className(), 'targetAttribute' => ['join_club_activity_uuid' => 'join_club_activity_uuid']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'join_club_activity_mapping_id' => Yii::t('app', 'Join Club Activity Mapping ID'),
            'join_club_activity_mapping_uuid' => Yii::t('app', 'Join Club Activity Mapping Uuid'),
            'join_club_activity_uuid' => Yii::t('app', 'Join Club Activity Uuid'),
            'join_club_uuid' => Yii::t('app', 'Join Club Uuid'),
            'join_club_activity_mapping_created_date' => Yii::t('app', 'Join Club Activity Mapping Created Date'),
            'join_club_activity_mapping_modified_date' => Yii::t('app', 'Join Club Activity Mapping Modified Date'),
            'join_club_activity_mapping_status' => Yii::t('app', 'Join Club Activity Mapping Status'),
            'join_club_activity_mapping_is_deleted' => Yii::t('app', 'Join Club Activity Mapping Is Deleted'),
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getJoinClubUu()
    {
        return $this->hasOne(JoinClub::className(), ['join_club_uuid' => 'join_club_uuid']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getJoinClubActivityUu()
    {
        return $this->hasOne(JoinClubActivity::className(), ['join_club_activity_uuid' => 'join_club_activity_uuid']);
    }

    /**
     * {@inheritdoc}
     * @return JoinClubActivityMappingQuery the active query used by this AR class.
     */
    public static function find()
    {
        return new JoinClubActivityMappingQuery(get_called_class());
    }
}
