<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "join_club_event_booking".
 *
 * @property int $join_club_event_booking_id
 * @property string $join_club_event_booking_uuid
 * @property string $join_club_event_uuid
 * @property string $join_club_event_booking_txn
 * @property string $join_club_event_booking_created_date
 * @property string $join_club_event_booking_modified_date
 * @property string $join_club_event_booking_coupon
 * @property double $join_club_event_booking_amount
 * @property double $join_club_event_booking_discount
 * @property string $join_club_event_booking_mode
 * @property string $join_club_event_booking_status
 * @property string $join_club_event_booking_is_deleted
 *
 * @property JoinClubEvent $joinClubEventUu
 */
class JoinClubEventBooking extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'join_club_event_booking';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['join_club_event_booking_uuid', 'join_club_event_uuid', 'join_club_event_booking_txn', 'join_club_event_booking_amount', 'join_club_event_booking_mode'], 'required'],
            [['join_club_event_booking_created_date', 'join_club_event_booking_modified_date'], 'safe'],
            [['join_club_event_booking_amount', 'join_club_event_booking_discount'], 'number'],
            [['join_club_event_booking_mode', 'join_club_event_booking_status', 'join_club_event_booking_is_deleted'], 'string'],
            [['join_club_event_booking_uuid', 'join_club_event_uuid', 'join_club_event_booking_txn'], 'string', 'max' => 64],
            [['join_club_event_booking_coupon'], 'string', 'max' => 32],
            [['join_club_event_booking_uuid'], 'unique'],
            [['join_club_event_uuid'], 'exist', 'skipOnError' => true, 'targetClass' => JoinClubEvent::className(), 'targetAttribute' => ['join_club_event_uuid' => 'join_club_event_uuid']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'join_club_event_booking_id' => Yii::t('app', 'Join Club Event Booking ID'),
            'join_club_event_booking_uuid' => Yii::t('app', 'Join Club Event Booking Uuid'),
            'join_club_event_uuid' => Yii::t('app', 'Join Club Event Uuid'),
            'join_club_event_booking_txn' => Yii::t('app', 'Join Club Event Booking Txn'),
            'join_club_event_booking_created_date' => Yii::t('app', 'Join Club Event Booking Created Date'),
            'join_club_event_booking_modified_date' => Yii::t('app', 'Join Club Event Booking Modified Date'),
            'join_club_event_booking_coupon' => Yii::t('app', 'Join Club Event Booking Coupon'),
            'join_club_event_booking_amount' => Yii::t('app', 'Join Club Event Booking Amount'),
            'join_club_event_booking_discount' => Yii::t('app', 'Join Club Event Booking Discount'),
            'join_club_event_booking_mode' => Yii::t('app', 'Join Club Event Booking Mode'),
            'join_club_event_booking_status' => Yii::t('app', 'Join Club Event Booking Status'),
            'join_club_event_booking_is_deleted' => Yii::t('app', 'Join Club Event Booking Is Deleted'),
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getJoinClubEventUu()
    {
        return $this->hasOne(JoinClubEvent::className(), ['join_club_event_uuid' => 'join_club_event_uuid']);
    }

    /**
     * {@inheritdoc}
     * @return JoinClubEventBookingQuery the active query used by this AR class.
     */
    public static function find()
    {
        return new JoinClubEventBookingQuery(get_called_class());
    }
}
