<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "join_email_cron".
 *
 * @property int $join_email_cron_id
 * @property string $join_email_cron_uuid
 * @property string $join_email_cron_email
 * @property string $join_email_cron_subject
 * @property string $join_email_cron_message
 * @property string $join_email_cron_created_date
 * @property string $join_email_cron_modified_date
 * @property string $join_email_cron_status
 * @property string $join_email_cron_is_deleted
 */
class JoinEmailCron extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'join_email_cron';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['join_email_cron_uuid', 'join_email_cron_email', 'join_email_cron_subject', 'join_email_cron_message'], 'required'],
            [['join_email_cron_message', 'join_email_cron_status', 'join_email_cron_is_deleted'], 'string'],
            [['join_email_cron_created_date', 'join_email_cron_modified_date'], 'safe'],
            [['join_email_cron_uuid'], 'string', 'max' => 64],
            [['join_email_cron_email'], 'string', 'max' => 128],
            [['join_email_cron_subject'], 'string', 'max' => 512],
            [['join_email_cron_uuid'], 'unique'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'join_email_cron_id' => Yii::t('app', 'Join Email Cron ID'),
            'join_email_cron_uuid' => Yii::t('app', 'Join Email Cron Uuid'),
            'join_email_cron_email' => Yii::t('app', 'Join Email Cron Email'),
            'join_email_cron_subject' => Yii::t('app', 'Join Email Cron Subject'),
            'join_email_cron_message' => Yii::t('app', 'Join Email Cron Message'),
            'join_email_cron_created_date' => Yii::t('app', 'Join Email Cron Created Date'),
            'join_email_cron_modified_date' => Yii::t('app', 'Join Email Cron Modified Date'),
            'join_email_cron_status' => Yii::t('app', 'Join Email Cron Status'),
            'join_email_cron_is_deleted' => Yii::t('app', 'Join Email Cron Is Deleted'),
        ];
    }

    /**
     * {@inheritdoc}
     * @return JoinEmailCronQuery the active query used by this AR class.
     */
    public static function find()
    {
        return new JoinEmailCronQuery(get_called_class());
    }
}
