<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "join_language_info".
 *
 * @property int $join_language_info_id
 * @property string $join_language_info_uuid
 * @property string $join_signup_uuid
 * @property string $join_language_name
 * @property string $join_language_info_created_date
 * @property string $join_language_info_modified_date
 * @property string $join_language_info_status
 * @property string $join_language_info_is_deleted
 *
 * @property JoinSignup $joinSignupUu
 */
class JoinLanguageInfo extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'join_language_info';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['join_language_info_uuid', 'join_signup_uuid'], 'required'],
            [['join_language_name', 'join_language_info_status', 'join_language_info_is_deleted'], 'string'],
            [['join_language_info_created_date', 'join_language_info_modified_date'], 'safe'],
            [['join_language_info_uuid', 'join_signup_uuid'], 'string', 'max' => 64],
            [['join_language_info_uuid'], 'unique'],
            [['join_signup_uuid'], 'exist', 'skipOnError' => true, 'targetClass' => JoinSignup::className(), 'targetAttribute' => ['join_signup_uuid' => 'join_signup_uuid']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'join_language_info_id' => Yii::t('app', 'Join Language Info ID'),
            'join_language_info_uuid' => Yii::t('app', 'Join Language Info Uuid'),
            'join_signup_uuid' => Yii::t('app', 'Join Signup Uuid'),
            'join_language_name' => Yii::t('app', 'Join Language Name'),
            'join_language_info_created_date' => Yii::t('app', 'Join Language Info Created Date'),
            'join_language_info_modified_date' => Yii::t('app', 'Join Language Info Modified Date'),
            'join_language_info_status' => Yii::t('app', 'Join Language Info Status'),
            'join_language_info_is_deleted' => Yii::t('app', 'Join Language Info Is Deleted'),
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getJoinSignupUu()
    {
        return $this->hasOne(JoinSignup::className(), ['join_signup_uuid' => 'join_signup_uuid']);
    }

    /**
     * {@inheritdoc}
     * @return JoinLanguageInfoQuery the active query used by this AR class.
     */
    public static function find()
    {
        return new JoinLanguageInfoQuery(get_called_class());
    }
}
