<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "join_otp".
 *
 * @property string $join_otp_id
 * @property string $join_otp_uuid
 * @property string $join_otp_number
 * @property string $join_otp_mobile
 * @property string $join_signup_uuid
 * @property string $join_otp_created_date
 * @property string $join_otp_modified_date
 * @property string $join_otp_status
 * @property string $join_otp_is_deleted
 *
 * @property JoinSignup $joinSignupUu
 */
class JoinOtp extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'join_otp';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['join_otp_uuid', 'join_otp_number', 'join_otp_mobile', 'join_signup_uuid'], 'required'],
            [['join_otp_created_date', 'join_otp_modified_date'], 'safe'],
            [['join_otp_status', 'join_otp_is_deleted'], 'string'],
            [['join_otp_uuid', 'join_signup_uuid'], 'string', 'max' => 64],
            [['join_otp_number'], 'string', 'max' => 8],
            [['join_otp_mobile'], 'string', 'max' => 32],
            [['join_otp_uuid'], 'unique'],
            [['join_signup_uuid'], 'exist', 'skipOnError' => true, 'targetClass' => JoinSignup::className(), 'targetAttribute' => ['join_signup_uuid' => 'join_signup_uuid']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'join_otp_id' => Yii::t('app', 'Join Otp ID'),
            'join_otp_uuid' => Yii::t('app', 'Join Otp Uuid'),
            'join_otp_number' => Yii::t('app', 'Join Otp Number'),
            'join_otp_mobile' => Yii::t('app', 'Join Otp Mobile'),
            'join_signup_uuid' => Yii::t('app', 'Join Signup Uuid'),
            'join_otp_created_date' => Yii::t('app', 'Join Otp Created Date'),
            'join_otp_modified_date' => Yii::t('app', 'Join Otp Modified Date'),
            'join_otp_status' => Yii::t('app', 'Join Otp Status'),
            'join_otp_is_deleted' => Yii::t('app', 'Join Otp Is Deleted'),
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getJoinSignupUu()
    {
        return $this->hasOne(JoinSignup::className(), ['join_signup_uuid' => 'join_signup_uuid']);
    }

    /**
     * {@inheritdoc}
     * @return JoinOtpQuery the active query used by this AR class.
     */
    public static function find()
    {
        return new JoinOtpQuery(get_called_class());
    }
}
