<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "join_sms_cron".
 *
 * @property int $join_sms_cron_id
 * @property string $join_sms_cron_uuid
 * @property string $join_sms_cron_mobile_number
 * @property string $join_sms_cron_message
 * @property string $join_sms_cron_created_date
 * @property string $join_sms_cron_modified_date
 * @property string $join_sms_cron_status
 * @property string $join_sms_cron_is_deleted
 */
class JoinSmsCron extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'join_sms_cron';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['join_sms_cron_uuid', 'join_sms_cron_mobile_number', 'join_sms_cron_message'], 'required'],
            [['join_sms_cron_message', 'join_sms_cron_status', 'join_sms_cron_is_deleted'], 'string'],
            [['join_sms_cron_created_date', 'join_sms_cron_modified_date'], 'safe'],
            [['join_sms_cron_uuid'], 'string', 'max' => 64],
            [['join_sms_cron_mobile_number'], 'string', 'max' => 16],
            [['join_sms_cron_uuid'], 'unique'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'join_sms_cron_id' => Yii::t('app', 'Join Sms Cron ID'),
            'join_sms_cron_uuid' => Yii::t('app', 'Join Sms Cron Uuid'),
            'join_sms_cron_mobile_number' => Yii::t('app', 'Join Sms Cron Mobile Number'),
            'join_sms_cron_message' => Yii::t('app', 'Join Sms Cron Message'),
            'join_sms_cron_created_date' => Yii::t('app', 'Join Sms Cron Created Date'),
            'join_sms_cron_modified_date' => Yii::t('app', 'Join Sms Cron Modified Date'),
            'join_sms_cron_status' => Yii::t('app', 'Join Sms Cron Status'),
            'join_sms_cron_is_deleted' => Yii::t('app', 'Join Sms Cron Is Deleted'),
        ];
    }

    /**
     * {@inheritdoc}
     * @return JoinSmsCronQuery the active query used by this AR class.
     */
    public static function find()
    {
        return new JoinSmsCronQuery(get_called_class());
    }
}
