<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "join_token".
 *
 * @property string $join_token_id
 * @property string $join_token_uuid
 * @property string $join_signup_uuid
 * @property string $join_token
 * @property string $join_token_created_date
 * @property string $join_token_modified_date
 * @property string $join_token_status
 * @property string $join_token_is_deleted
 *
 * @property JoinSignup $joinSignupUu
 */
class JoinToken extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'join_token';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['join_token_uuid', 'join_signup_uuid', 'join_token', 'join_token_modified_date'], 'required'],
            [['join_token_created_date', 'join_token_modified_date'], 'safe'],
            [['join_token_status', 'join_token_is_deleted'], 'string'],
            [['join_token_uuid', 'join_signup_uuid'], 'string', 'max' => 64],
            [['join_token'], 'string', 'max' => 32],
            [['join_token_uuid'], 'unique'],
            [['join_signup_uuid'], 'exist', 'skipOnError' => true, 'targetClass' => JoinSignup::className(), 'targetAttribute' => ['join_signup_uuid' => 'join_signup_uuid']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'join_token_id' => Yii::t('app', 'Join Token ID'),
            'join_token_uuid' => Yii::t('app', 'Join Token Uuid'),
            'join_signup_uuid' => Yii::t('app', 'Join Signup Uuid'),
            'join_token' => Yii::t('app', 'Join Token'),
            'join_token_created_date' => Yii::t('app', 'Join Token Created Date'),
            'join_token_modified_date' => Yii::t('app', 'Join Token Modified Date'),
            'join_token_status' => Yii::t('app', 'Join Token Status'),
            'join_token_is_deleted' => Yii::t('app', 'Join Token Is Deleted'),
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getJoinSignupUu()
    {
        return $this->hasOne(JoinSignup::className(), ['join_signup_uuid' => 'join_signup_uuid']);
    }

    /**
     * {@inheritdoc}
     * @return JoinTokenQuery the active query used by this AR class.
     */
    public static function find()
    {
        return new JoinTokenQuery(get_called_class());
    }
}
