<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "join_user_activity_mapping".
 *
 * @property int $join_user_activity_mapping_id
 * @property string $join_user_activity_mapping_uuid
 * @property string $join_signup_uuid
 * @property string $join_club_activity_uuid
 * @property string $join_user_activity_mapping_created_date
 * @property string $join_user_activity_mapping_modified_date
 * @property string $join_user_activity_mapping_status
 * @property string $join_user_activity_mapping_is_deleted
 *
 * @property JoinSignup $joinSignupUu
 */
class JoinUserActivityMapping extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'join_user_activity_mapping';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['join_user_activity_mapping_uuid', 'join_signup_uuid', 'join_club_activity_uuid'], 'required'],
            [['join_user_activity_mapping_created_date', 'join_user_activity_mapping_modified_date'], 'safe'],
            [['join_user_activity_mapping_status', 'join_user_activity_mapping_is_deleted'], 'string'],
            [['join_user_activity_mapping_uuid', 'join_signup_uuid', 'join_club_activity_uuid'], 'string', 'max' => 64],
            [['join_user_activity_mapping_uuid'], 'unique'],
            [['join_signup_uuid'], 'exist', 'skipOnError' => true, 'targetClass' => JoinSignup::className(), 'targetAttribute' => ['join_signup_uuid' => 'join_signup_uuid']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'join_user_activity_mapping_id' => Yii::t('app', 'Join User Activity Mapping ID'),
            'join_user_activity_mapping_uuid' => Yii::t('app', 'Join User Activity Mapping Uuid'),
            'join_signup_uuid' => Yii::t('app', 'Join Signup Uuid'),
            'join_club_activity_uuid' => Yii::t('app', 'Join Club Activity Uuid'),
            'join_user_activity_mapping_created_date' => Yii::t('app', 'Join User Activity Mapping Created Date'),
            'join_user_activity_mapping_modified_date' => Yii::t('app', 'Join User Activity Mapping Modified Date'),
            'join_user_activity_mapping_status' => Yii::t('app', 'Join User Activity Mapping Status'),
            'join_user_activity_mapping_is_deleted' => Yii::t('app', 'Join User Activity Mapping Is Deleted'),
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getJoinSignupUu()
    {
        return $this->hasOne(JoinSignup::className(), ['join_signup_uuid' => 'join_signup_uuid']);
    }

    /**
     * {@inheritdoc}
     * @return JoinUserActivityMappingQuery the active query used by this AR class.
     */
    public static function find()
    {
        return new JoinUserActivityMappingQuery(get_called_class());
    }
}
