<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "join_user_detail".
 *
 * @property int $join_user_detail_id
 * @property string $join_user_detail_uuid
 * @property string $join_signup_uuid
 * @property string $join_user_photo
 * @property string $join_user_type
 * @property string $parent_user_uuid
 * @property string $join_user_address
 * @property string $join_area_master_uuid
 * @property int $join_user_age
 * @property string $join_user_dob
 * @property string $join_user_city
 * @property string $join_user_pin
 * @property string $join_user_gender
 * @property string $join_user_joining_id
 * @property string $join_user_detail_created_date
 * @property string $join_user_detail_modified_date
 * @property string $join_user_detail_status
 * @property string $join_user_detail_is_deleted
 *
 * @property JoinSignup $joinSignupUu
 * @property JoinAreaMaster $joinAreaMasterUu
 */
class JoinUserDetail extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'join_user_detail';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['join_user_detail_uuid', 'join_signup_uuid', 'join_user_address', 'join_area_master_uuid', 'join_user_city', 'join_user_pin', 'join_user_gender', 'join_user_joining_id'], 'required'],
            [['join_user_photo', 'join_user_type', 'join_user_address', 'join_user_gender', 'join_user_detail_status', 'join_user_detail_is_deleted'], 'string'],
            [['join_user_age'], 'integer'],
            [['join_user_dob', 'join_user_detail_created_date', 'join_user_detail_modified_date'], 'safe'],
            [['join_user_detail_uuid', 'join_signup_uuid', 'parent_user_uuid', 'join_area_master_uuid'], 'string', 'max' => 64],
            [['join_user_city'], 'string', 'max' => 512],
            [['join_user_pin', 'join_user_joining_id'], 'string', 'max' => 16],
            [['join_user_detail_uuid'], 'unique'],
            [['join_signup_uuid'], 'exist', 'skipOnError' => true, 'targetClass' => JoinSignup::className(), 'targetAttribute' => ['join_signup_uuid' => 'join_signup_uuid']],
            [['join_area_master_uuid'], 'exist', 'skipOnError' => true, 'targetClass' => JoinAreaMaster::className(), 'targetAttribute' => ['join_area_master_uuid' => 'join_area_master_uuid']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'join_user_detail_id' => Yii::t('app', 'Join User Detail ID'),
            'join_user_detail_uuid' => Yii::t('app', 'Join User Detail Uuid'),
            'join_signup_uuid' => Yii::t('app', 'Join Signup Uuid'),
            'join_user_photo' => Yii::t('app', 'Join User Photo'),
            'join_user_type' => Yii::t('app', 'Join User Type'),
            'parent_user_uuid' => Yii::t('app', 'Parent User Uuid'),
            'join_user_address' => Yii::t('app', 'Join User Address'),
            'join_area_master_uuid' => Yii::t('app', 'Join Area Master Uuid'),
            'join_user_age' => Yii::t('app', 'Join User Age'),
            'join_user_dob' => Yii::t('app', 'Join User Dob'),
            'join_user_city' => Yii::t('app', 'Join User City'),
            'join_user_pin' => Yii::t('app', 'Join User Pin'),
            'join_user_gender' => Yii::t('app', 'Join User Gender'),
            'join_user_joining_id' => Yii::t('app', 'Join User Joining ID'),
            'join_user_detail_created_date' => Yii::t('app', 'Join User Detail Created Date'),
            'join_user_detail_modified_date' => Yii::t('app', 'Join User Detail Modified Date'),
            'join_user_detail_status' => Yii::t('app', 'Join User Detail Status'),
            'join_user_detail_is_deleted' => Yii::t('app', 'Join User Detail Is Deleted'),
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getJoinSignupUu()
    {
        return $this->hasOne(JoinSignup::className(), ['join_signup_uuid' => 'join_signup_uuid']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getJoinAreaMasterUu()
    {
        return $this->hasOne(JoinAreaMaster::className(), ['join_area_master_uuid' => 'join_area_master_uuid']);
    }

    /**
     * {@inheritdoc}
     * @return JoinUserDetailQuery the active query used by this AR class.
     */
    public static function find()
    {
        return new JoinUserDetailQuery(get_called_class());
    }
}
