<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "sso_otp".
 *
 * @property int $id
 * @property string $registration_number
 * @property int $mobile_number
 * @property int $otp
 * @property string $is_active
 * @property string $created_datetime
 * @property string $modified_date
 */
class SsoOtp extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'sso_otp';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['registration_number', 'mobile_number', 'otp'], 'required'],
            [['mobile_number', 'otp'], 'integer'],
            [['is_active'], 'string'],
            [['created_datetime', 'modified_date'], 'safe'],
            [['registration_number'], 'string', 'max' => 64],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => Yii::t('app', 'ID'),
            'registration_number' => Yii::t('app', 'Registration Number'),
            'mobile_number' => Yii::t('app', 'Mobile Number'),
            'otp' => Yii::t('app', 'Otp'),
            'is_active' => Yii::t('app', 'Is Active'),
            'created_datetime' => Yii::t('app', 'Created Datetime'),
            'modified_date' => Yii::t('app', 'Modified Date'),
        ];
    }

    /**
     * {@inheritdoc}
     * @return SsoOtpQuery the active query used by this AR class.
     */
    public static function find()
    {
        return new SsoOtpQuery(get_called_class());
    }
}
