<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "sso_role_information".
 *
 * @property int $role_id
 * @property string $role_uuid
 * @property string $role_name
 * @property string $role_status
 * @property string $role_created_date
 * @property string $role_deleted_date
 * @property string $role_is_deleted
 * @property string $modified_date
 */
class SsoRoleInformation extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'sso_role_information';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['role_uuid', 'role_name'], 'required'],
            [['role_status', 'role_is_deleted'], 'string'],
            [['role_created_date', 'role_deleted_date', 'modified_date'], 'safe'],
            [['role_uuid'], 'string', 'max' => 128],
            [['role_name'], 'string', 'max' => 256],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'role_id' => Yii::t('app', 'Role ID'),
            'role_uuid' => Yii::t('app', 'Role Uuid'),
            'role_name' => Yii::t('app', 'Role Name'),
            'role_status' => Yii::t('app', 'Role Status'),
            'role_created_date' => Yii::t('app', 'Role Created Date'),
            'role_deleted_date' => Yii::t('app', 'Role Deleted Date'),
            'role_is_deleted' => Yii::t('app', 'Role Is Deleted'),
            'modified_date' => Yii::t('app', 'Modified Date'),
        ];
    }

    /**
     * {@inheritdoc}
     * @return SsoRoleInformationQuery the active query used by this AR class.
     */
    public static function find()
    {
        return new SsoRoleInformationQuery(get_called_class());
    }
}
