<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "sso_user_accessright".
 *
 * @property int $accessright_id
 * @property string $accessright_uuid
 * @property string $user_uuid
 * @property string $permission_uuid
 * @property string $accessright_created_date
 * @property string $accessright_added_date
 * @property string $accessright_status
 * @property string $accessright_is_deleted
 * @property string $accessright_modified_date
 * @property string $modified_date
 */
class SsoUserAccessright extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'sso_user_accessright';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['accessright_uuid', 'user_uuid', 'permission_uuid'], 'required'],
            [['accessright_created_date', 'accessright_added_date', 'accessright_modified_date', 'modified_date'], 'safe'],
            [['accessright_status', 'accessright_is_deleted'], 'string'],
            [['accessright_uuid', 'user_uuid', 'permission_uuid'], 'string', 'max' => 128],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'accessright_id' => Yii::t('app', 'Accessright ID'),
            'accessright_uuid' => Yii::t('app', 'Accessright Uuid'),
            'user_uuid' => Yii::t('app', 'User Uuid'),
            'permission_uuid' => Yii::t('app', 'Permission Uuid'),
            'accessright_created_date' => Yii::t('app', 'Accessright Created Date'),
            'accessright_added_date' => Yii::t('app', 'Accessright Added Date'),
            'accessright_status' => Yii::t('app', 'Accessright Status'),
            'accessright_is_deleted' => Yii::t('app', 'Accessright Is Deleted'),
            'accessright_modified_date' => Yii::t('app', 'Accessright Modified Date'),
            'modified_date' => Yii::t('app', 'Modified Date'),
        ];
    }

    /**
     * {@inheritdoc}
     * @return SsoUserAccessrightQuery the active query used by this AR class.
     */
    public static function find()
    {
        return new SsoUserAccessrightQuery(get_called_class());
    }
}
