<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "sso_user_information".
 *
 * @property int $user_id
 * @property string $user_uuid
 * @property string $user_email
 * @property string $user_email_confirmed
 * @property string $password_hash
 * @property string $user_hkey
 * @property string $user_mobile
 * @property string $mobile_number_confirmed
 * @property string $lockout_end_date
 * @property string $lock_out_enabled
 * @property int $access_failed_count
 * @property string $user_name
 * @property string $device_uuid
 * @property string $reset_key
 * @property int $registration_year
 * @property string $user_status
 * @property string $user_created_date
 * @property string $user_created_by
 * @property string $user_modified_date
 * @property string $user_modified_by
 * @property string $user_deleted_by
 * @property string $user_deleted_date
 * @property string $user_is_deleted
 * @property string $modified_date
 */
class SsoUserInformation extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'sso_user_information';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['user_uuid', 'password_hash', 'user_hkey', 'user_mobile', 'user_name'], 'required'],
            [['user_email_confirmed', 'mobile_number_confirmed', 'lock_out_enabled', 'user_status', 'user_is_deleted'], 'string'],
            [['lockout_end_date', 'user_created_date', 'user_modified_date', 'user_deleted_date', 'modified_date'], 'safe'],
            [['access_failed_count', 'registration_year'], 'integer'],
            [['user_uuid', 'user_email', 'password_hash', 'user_hkey', 'user_name', 'user_created_by', 'user_modified_by', 'user_deleted_by'], 'string', 'max' => 128],
            [['user_mobile'], 'string', 'max' => 16],
            [['device_uuid', 'reset_key'], 'string', 'max' => 64],
            [['device_uuid'], 'unique'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'user_id' => Yii::t('app', 'User ID'),
            'user_uuid' => Yii::t('app', 'User Uuid'),
            'user_email' => Yii::t('app', 'User Email'),
            'user_email_confirmed' => Yii::t('app', 'User Email Confirmed'),
            'password_hash' => Yii::t('app', 'Password Hash'),
            'user_hkey' => Yii::t('app', 'User Hkey'),
            'user_mobile' => Yii::t('app', 'User Mobile'),
            'mobile_number_confirmed' => Yii::t('app', 'Mobile Number Confirmed'),
            'lockout_end_date' => Yii::t('app', 'Lockout End Date'),
            'lock_out_enabled' => Yii::t('app', 'Lock Out Enabled'),
            'access_failed_count' => Yii::t('app', 'Access Failed Count'),
            'user_name' => Yii::t('app', 'User Name'),
            'device_uuid' => Yii::t('app', 'Device Uuid'),
            'reset_key' => Yii::t('app', 'Reset Key'),
            'registration_year' => Yii::t('app', 'Registration Year'),
            'user_status' => Yii::t('app', 'User Status'),
            'user_created_date' => Yii::t('app', 'User Created Date'),
            'user_created_by' => Yii::t('app', 'User Created By'),
            'user_modified_date' => Yii::t('app', 'User Modified Date'),
            'user_modified_by' => Yii::t('app', 'User Modified By'),
            'user_deleted_by' => Yii::t('app', 'User Deleted By'),
            'user_deleted_date' => Yii::t('app', 'User Deleted Date'),
            'user_is_deleted' => Yii::t('app', 'User Is Deleted'),
            'modified_date' => Yii::t('app', 'Modified Date'),
        ];
    }

    /**
     * {@inheritdoc}
     * @return SsoUserInformationQuery the active query used by this AR class.
     */
    public static function find()
    {
        return new SsoUserInformationQuery(get_called_class());
    }
}
