<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "sso_user_role".
 *
 * @property int $user_role_id
 * @property string $user_role_uuid
 * @property string $user_role
 * @property string $user_uuid
 * @property string $user_role_permission
 * @property string $user_role_status
 * @property string $user_role_created_date
 * @property string $user_role_is_deleted
 * @property string $user_role_deleted_date
 * @property string $modified_date
 */
class SsoUserRole extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'sso_user_role';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['user_role_uuid', 'user_role', 'user_uuid'], 'required'],
            [['user_role', 'user_role_permission', 'user_role_status', 'user_role_is_deleted'], 'string'],
            [['user_role_created_date', 'user_role_deleted_date', 'modified_date'], 'safe'],
            [['user_role_uuid', 'user_uuid'], 'string', 'max' => 128],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'user_role_id' => Yii::t('app', 'User Role ID'),
            'user_role_uuid' => Yii::t('app', 'User Role Uuid'),
            'user_role' => Yii::t('app', 'User Role'),
            'user_uuid' => Yii::t('app', 'User Uuid'),
            'user_role_permission' => Yii::t('app', 'User Role Permission'),
            'user_role_status' => Yii::t('app', 'User Role Status'),
            'user_role_created_date' => Yii::t('app', 'User Role Created Date'),
            'user_role_is_deleted' => Yii::t('app', 'User Role Is Deleted'),
            'user_role_deleted_date' => Yii::t('app', 'User Role Deleted Date'),
            'modified_date' => Yii::t('app', 'Modified Date'),
        ];
    }

    /**
     * {@inheritdoc}
     * @return SsoUserRoleQuery the active query used by this AR class.
     */
    public static function find()
    {
        return new SsoUserRoleQuery(get_called_class());
    }
}
