<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "sso_user_token".
 *
 * @property string $sso_user_token_id
 * @property string $sso_user_token_uuid
 * @property string $user_uuid
 * @property string $token
 * @property string $sso_user_token_created_date
 * @property string $sso_user_token_modified_date
 * @property string $token_status
 * @property string $token_is_deleted
 *
 * @property JoinSignup $userUu
 */
class SsoUserToken extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'sso_user_token';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['sso_user_token_uuid', 'user_uuid', 'token'], 'required'],
            [['sso_user_token_created_date', 'sso_user_token_modified_date'], 'safe'],
            [['token_status', 'token_is_deleted'], 'string'],
            [['sso_user_token_uuid', 'user_uuid'], 'string', 'max' => 64],
            [['token'], 'string', 'max' => 32],
            [['sso_user_token_uuid'], 'unique'],
            [['user_uuid'], 'unique'],
            [['user_uuid'], 'exist', 'skipOnError' => true, 'targetClass' => JoinSignup::className(), 'targetAttribute' => ['user_uuid' => 'join_signup_uuid']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'sso_user_token_id' => Yii::t('app', 'Sso User Token ID'),
            'sso_user_token_uuid' => Yii::t('app', 'Sso User Token Uuid'),
            'user_uuid' => Yii::t('app', 'User Uuid'),
            'token' => Yii::t('app', 'Token'),
            'sso_user_token_created_date' => Yii::t('app', 'Sso User Token Created Date'),
            'sso_user_token_modified_date' => Yii::t('app', 'Sso User Token Modified Date'),
            'token_status' => Yii::t('app', 'Token Status'),
            'token_is_deleted' => Yii::t('app', 'Token Is Deleted'),
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getUserUu()
    {
        return $this->hasOne(JoinSignup::className(), ['join_signup_uuid' => 'user_uuid']);
    }

    /**
     * {@inheritdoc}
     * @return SsoUserTokenQuery the active query used by this AR class.
     */
    public static function find()
    {
        return new SsoUserTokenQuery(get_called_class());
    }
}
