<?php
namespace app\modules\admin\controllers;
use app\models\Session;
use YII;
use yii\filters\AccessControl;

class ChallanresetController extends \yii\web\Controller {
	public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'rules' => [
                    [
                        'allow' =>  Yii::$app->utility->isSuperAdmin() || Yii::$app->utility->isHelpDeskUser(),
                    ],

                ],
                'denyCallback' => function ($rule, $action) {
                    if (Yii::$app->utility->isSuperAdmin() === false) {
                        return $action->controller->redirect(BASE_URL.'/site/login');
                    }
                    throw new ForbiddenHttpException("Forbidden access");
                }
            ],

        ];
    }


	public function actionIndex() {

		//$role = Yii::$app->utility->getRole();

		//if ($role == 'ADMIN') {
			return $this->render('index');
		//} else {
			//return $this->redirect(BASE_URL . '/admin');
		//}

	}
	public function actionGetchallan() {

		$challanno = $_POST['challanno'];
		$session = $this->actionGetAcedemicSession();
		$connection = \Yii::$app->db;
		$query = $connection->createCommand("SELECT  StudentType FROM h_challantable
			WHERE ChallanID = $challanno");
		$studentType = $query->queryOne();
		if ($studentType[StudentType] == "NEW") {

			$model = $connection->createCommand("SELECT CT.application_number,CT.course_section_id,CC.collegecourseid,ChallanID, StudentType,challantable_status, CT.IsActive, Application_Number, StudentName,IsPayment , FatherName, sectionname
            FROM h_challantable CT
            INNER Join applicant_application_course_choice ACC ON ACC.application_application_number= CT.application_Number
            INNER JOIN  dhe_legacy_collegecourse  CC ON CC.collegecourseid =CT.course_section_id
            INNER JOIN dhe_legacy_coursesection CS ON CS.coursesectionid = CC.sectionid
			WHERE ChallanID=$challanno");
			
			// $model = $connection->createCommand("SELECT *
			// FROM h_challantable 
			// WHERE ChallanID = $challanno");

			$data['row'] = $model->queryOne();

			if (empty($data['row'])) {
				echo false;

			} else {
				return $this->renderPartial('table', $data);

			}

		} else {

			$model = $connection->createCommand("SELECT
			ChallanID, StudentType,challantable_status,CT.IsActive, S.application_number as Application_Number, student_name as StudentName,
			father_name as FatherName, sectionname
			FROM h_challantable CT
			INNER Join student_information S ON S.application_number= CT.application_Number
			INNER JOIN confirmed_student_table HCS ON HCS.student_id = S.student_id
			INNER JOIN dhe_legacy_collegecourse CC ON CC.collegecourseid =HCS.course_section_id
			INNER JOIN dhe_legacy_coursesection CS ON CS.coursesectionid = CC.sectionid
			WHERE ChallanID = $challanno and HCS.session_id =$session");

			$data['row'] = $model->queryOne();

			if (empty($data['row'])) {
				echo false;

			} else {
				return $this->renderPartial('table', $data);

			}

		}

	}

	public function actionRessetchallan() {

		$challanno = $_POST['challanno'];
		$studenttype = $_POST['studenttype'];
		$appno = $_POST['appno'];
		$session = $this->actionGetAcedemicSession();
		$connection = \Yii::$app->db;
		$studentId = $connection->createCommand("SELECT S.Student_id
		FROM `student_information` S INNER JOIN confirmed_student_table CS on S.student_id = CS.Student_id
		WHERE `application_number` ='$appno' and CS.session_id=$session");

		$student_id = $studentId->queryOne();
		
		if ($studenttype == "NEW") {
			$connection = \Yii::$app->db;
			$transaction = $connection->beginTransaction();
			try {
				$connection->createCommand("UPDATE h_challantable SET IsActive=0 , challantable_status='INACTIVE' ,challantable_is_deleted='YES'  WHERE ChallanID = $challanno AND IsPayment = 0")->execute();
				$connection->createCommand("UPDATE  collegecourse_merit_list_2018 SET is_verified='SUBJECT_ALLOCTED'  WHERE application_number='$appno' and is_verified='CHALAN_CREATED'")->execute();
				$connection->createCommand("UPDATE  collegecourse_merit_list_2018_pg SET is_verified='SUBJECT_ALLOCTED'  WHERE application_number='$appno' and is_verified='CHALAN_CREATED'")->execute();
				$connection->createCommand("UPDATE  pg_waiting_list_2018 SET is_verified='SUBJECT_ALLOCTED'  WHERE application_number='$appno' and is_verified='CHALAN_CREATED'")->execute();
				//.... other SQL executions
				$transaction->commit();
				echo "Successfully Updated!";
			} catch (\Exception $e) {
				$transaction->rollBack();
				throw $e;
			} catch (\Throwable $e) {
				$transaction->rollBack();
				throw $e;
			}

		} else {

			$connection = \Yii::$app->db;
			$transaction = $connection->beginTransaction();

			try { 
				$connection->createCommand("UPDATE h_challantable SET IsActive=0 , challantable_status='INACTIVE' , challantable_is_deleted='YES'   WHERE ChallanID = $challanno  AND IsPayment = 0")->execute();
				$connection->createCommand("UPDATE confirmed_student_table SET status= 3 , is_promoted_status='SUBJECT_ALLOCTED' WHERE student_id='" . $student_id['Student_id'] . "' AND session_id =$session")->execute(); 
				//.... other SQL executions
				$transaction->commit();
				echo "Successfully Updated!";
			} catch (\Exception $e) {
				$transaction->rollBack();
				throw $e;
			} catch (\Throwable $e) {
				$transaction->rollBack();
				throw $e;
			}

		}

	}

	public function actionGetAcedemicSession() {
		$sessionarr = Session::find()
			->select('SessionID')
			->where('Status = :status', [':status' => 1])
			->one();

		return $sessionarr['SessionID'];
	}

}
