<?php
namespace app\modules\admin\controllers;
$connection = \Yii::$app->db;
use app\models\DheLegacyCollege;
use app\models\Session;
use YII;
use yii\filters\AccessControl;
use yii\db\Query;

class MeritlistingController extends \yii\web\Controller {
    
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'rules' => [
                    [
                        'allow' =>  Yii::$app->utility->isSuperAdmin() || Yii::$app->utility->isHelpDeskUser(),
                    ],

                ],
                'denyCallback' => function ($rule, $action) {
                    if (Yii::$app->utility->isSuperAdmin() === false) {
                        return $action->controller->redirect(BASE_URL.'/site/login');
                    }
                    throw new ForbiddenHttpException("Forbidden access");
                }
            ],

        ];
    }
 
    public function actionIndex(){
       // $this->layout = "Merit List";
        $data['sessionid'] = $this->getAcedemicSession();
        $data['districts'] = $this->getDistricts();
        $data['courses'] = array();
        $data['cate'] = $this->actionGetcate();       

        return $this->render('meritlist',$data);
    }

    //Get currently active acedemic session
    public function getAcedemicSession() {
        $sessionarr = Session::find()
            ->select('SessionID')
            ->where('Status = :status', [':status' => 1])
            ->one();

        return $sessionarr['SessionID'];
    }

    private function getDistricts() {
        $state_uuid = "FAEAC4E1EEF307C2AB7B0A3821E6C667";
		$query = new Query;
		$query->select(['district_id', 'district_name'])
			->from('erp_master_district')
		    ->where('state_uuid = :state_uuid', [':state_uuid' => "$state_uuid"])
			->orderBy([
				'district_name' => SORT_ASC,
			]);
		$command = $query->createCommand();
		$districts = $command->queryAll();
        return $districts;
    }

    
    public function getData(){
        // $sql = "Select  ml.Challan_status,
        //         CASE
        //             WHEN ml.is_verified = 'SUBJECT_ALLOCTED' THEN 'SUBJECT ALLOCATED'
        //             WHEN ml.is_verified = 'CHALAN_CREATED' THEN 'CHALLAN CREATED'
        //             ELSE ml.is_verified
        //         END As is_verified,
        // ml.merit_applicant_type ,  ai.applicant_info_mobile_number,ml.category_name
        // ,ml.applicant_annual_income,ml.qualification,gen.gender_name,cho.application_application_number
        // ,ai.applicant_info_registration_number ,
        // ml.applicant_name , ml.applicant_father_name ,ml.applicant_mother_name ,ml.applicant_info_uuid, 
        // DATE_FORMAT(ml.applicant_dob,'%d/%m/%Y') as applicant_dob ,ml.category_name 
        // ,ml.applicant_qualification_percentage , ml.merit_uuid ,
        // ml.applicant_weightage,round(ml.total_applicant_weightage,2) as total_applicant_weightage,ml.college_course_id 
        // FROM collegecourse_merit_list_2018 ml 
        // inner join applicant_info ai on ai.applicant_info_uuid=ml.applicant_info_uuid 
        // inner join erp_master_gender gen on gen.gender_uuid=ai.gender_uuid 
        // inner join applicant_application_course_choice cho on cho.applicant_application_uuid=ml.applicant_info_uuid
        // WHERE  ml.round IN ('P1' , 'P2' ) AND application_course_choice_status = 'ACTIVE'
        // AND application_course_choice_is_deleted = 'NO' and ml.is_status = 'ACTIVE' 
        // and ml.is_deleted = 'NO' ORDER BY merit_id ASC";

        // $connection = \Yii::$app->db;
        // $model = $connection->createCommand($sql);
        // $data = $model->queryAll();
        // // echo "<pre>";
        // // print_r($data);
        // // die;
        // return $this->render('meritlist', [
        //     'merit' => $data,
        // ]);
    }

    private function actionGetcate() {
		$connection = Yii::$app->db;
		$query = "SELECT category_uuid,category_name  FROM erp_master_category
		WHERE category_status='Active' AND category_is_deleted='No'";
		$command = $connection->createCommand($query);
		$rows = $command->queryAll();
		return $rows;

	}

    private function actionCollegetype() {
		$collegeType = 1;
		$collegetype = DheLegacyHCollegetype::find()
			->select('collegetypeid , shortname')
            ->where('isactive = :isactive', [':isactive' => $collegeType])
            ->andWhere(['<=', 'collegetypeid','3'])
			->asArray()
			->one();
		return $collegetype['collegetypeid'];

	}

    //Get currently active acedemic session
	public function actionGetAcedemicSession() {
		$sessionarr = Session::find()
			->select('SessionID')
			->where('Status = :status', [':status' => 1])
			->one();

		return $sessionarr['SessionID'];
	}


    private function actionGetvaild_date($meritListNo, $courseId, $collegeId) {

		$collegeType = $this->actionCollegetype();

		$meritListNo = $meritListNo;
		$courseId = $courseId;
		$collegeid = $collegeId;
		$universityId = DheLegacyCollege::find()
			->where('collegeid = :collegeid', [':collegeid' => $collegeid])
			->select('affliationid')
			->asArray()
			->one();
		$universityid = $universityId['affliationid'];
		$sessionId = $this->actionGetAcedemicSession();

		$connection = Yii::$app->db;

		$query = "select end_date as Valid_Upto from dhe_legacy_h_meritList_ValidUpto MV
		INNER JOIN dhe_legacy_course C ON C.coursemode= MV.course_mode
		where  MV.university_id =$universityid  ANd MV.college_type_id=$collegeType AND
		meritlist_number =$meritListNo AND session_id=$sessionId ANd C.courseid=$courseId
		AND MV.is_active='ACTIVE'";

		$command = $connection->createCommand($query);
		$row = $command->queryOne();
		return $row['Valid_Upto'];

	}

    public function actionGetdata() {

		$collegeId = $_POST['college'];
		$course = $_POST['course'];
		$section = $_POST['section'];
		$category = $_POST['category'];
		$merit_no = $_POST['merit'];
		//college
		$col = DheLegacyCollege::find()
			->where('collegeid = :collegeid', [':collegeid' => $collegeId])
			->asArray()
			->one();

		//session
		//$sessionId = $this->actionCurrentsesion();
		//collge type
		$collegetypeid = $this->actionCollegetype();

		//college uuid
		$collegeUuid = $col['college_uuid'];

		$data['colname'] = $col['collegename'];
		$data['validdate'] = $this->actionGetvaild_date($merit_no, $course, $collegeId);

		$connection = Yii::$app->db;
		$query = "SELECT applicant_application_number as applicant_no,applicant_name ,applicant_info_registration_number as registration_no , applicant_fathername,ML.applicant_info_haryana_domicile AS 'Domicile',
                                        C.category_name AS 'Category',
                                        applicant_12th_marks AS '12th(%)',
                                        applicant_total_weightage AS 'Total Weightgae',
                                        (final_percentage) AS 'Final Percentage',
                                        applicant_status,IFNULL(remarks,'') AS Remarks,
                                        (CASE WHEN is_aig='YES' THEN 'All India Category' when is_general='YES' THEN 'General Category including Harayana ' WHEN PC.parentcategory_Id=6 THEN 'Physically Handicapped/FF/ESM' ELSE PC.parentcategory_name END ) as MeritCategoryName,
                                              (CASE WHEN is_aig='YES' THEN 1 when is_general='YES' THEN 2 ELSE PC.parentcategory_Id END ) as MeritCategoryID ,
                                              DATE_FORMAT(AI.applicant_info_date_of_birth, '%d-%m-%Y')AS DOB
			FROM applicant_meritlist ML
			INNER JOIN erp_master_parent_catgeory PC ON PC.parentcategory_uuid=ML.merit_category_uuid
			INNER JOIN applicant_info AI ON AI.applicant_info_uuid=ML.applicant_info_uuid
			INNER JOIN erp_master_category C ON C.category_uuid=AI.category_uuid

			WHERE (ML.category_uuid='0' OR '0'='0')
			AND (applicant_course_section_id='" . $section . "' OR '" . $section . "'=0)
			AND(meritlist_number=$merit_no   OR  $merit_no=0)
			AND (college_id='" . $collegeUuid . "');
			order by MeritCategoryID asc, final_percentage DESC;";

		$command = $connection->createCommand($query);
		//echo $connection->createCommand($query)->getRawSql();
		//die();
		$rows = $command->queryAll();
		$query = "SELECT CS.sectionname FROM dhe_legacy_collegecourse CC
		INNER JOIN  dhe_legacy_coursesection CS ON CS.coursesectionid=CC.sectionid
		WHERE CC.collegecourseid='" . $_POST['section'] . "' ";
		$command = $connection->createCommand($query);
		$sectionname = $command->queryOne();

		$data['coursename'] = $sectionname['sectionname'];
		$data['course'] = $course;
		$data['section'] = $section;
		$data['rows'] = $rows;
        $data['merit_no'] = $merit_no;
		//echo "<pre>";print_r($data);exit;
		return $this->renderPartial('table', $data);
	}



     public function actionMeritlistschedule(){

         $this->layout = "innerLayout";

        return $this->render('meritlistschedule', $data );

    }

     public function actionAdmissionsprospectus(){


         $this->layout = "innerLayout";

        return $this->render('admissionsprospectus' );

    }

    /**
     * Lists all get college courses of current session.
     * @return mixed
     */	
    public function actionGetprovisionalist(){
      //print_r($_POST);die;
       $connection = Yii::$app->db;
        if(isset($_POST['provison_round']) && $_POST['provison_round'] == 'P1'){
            $and = "AND round in ('P1','P2')";
        }else{
            $and = "AND round in ('P3','P4')";
        }

		 $sql = "Select  ml.Challan_status,
                CASE
                    WHEN ml.is_verified = 'SUBJECT_ALLOCTED' THEN 'SUBJECT ALLOCATED'
                    WHEN ml.is_verified = 'CHALAN_CREATED' THEN 'CHALLAN CREATED'
                    ELSE ml.is_verified
                END As is_verified,
        ml.merit_applicant_type ,  ai.applicant_info_mobile_number,ml.category_name
        ,ml.applicant_annual_income,ml.qualification,gen.gender_name,ml.application_number
        ,ai.applicant_info_registration_number ,
        ml.applicant_name , ml.applicant_father_name ,ml.applicant_mother_name ,ml.applicant_info_uuid, 
        DATE_FORMAT(ml.applicant_dob,'%d/%m/%Y') as applicant_dob ,ml.category_name 
        ,ml.applicant_qualification_percentage , ml.merit_uuid ,
        ml.applicant_weightage,round(ml.total_applicant_weightage,2) as total_applicant_weightage,ml.college_course_id 
        FROM collegecourse_merit_list_2018 ml 
        inner join applicant_info ai on ai.applicant_info_uuid=ml.applicant_info_uuid 
        inner join erp_master_gender gen on gen.gender_uuid=ai.gender_uuid 
        WHERE (ml.application_number='".$_POST['applicant_id']."' or ai.applicant_info_registration_number = '".$_POST['applicant_id']."')
        AND is_status = 'ACTIVE' AND is_deleted = 'NO' ORDER BY ml.total_applicant_weightage desc";
      // print_r($sql);die;

        $connection = \Yii::$app->db;
        $model = $connection->createCommand($sql);
        $data = $model->queryAll();
        return json_encode($data);
        // return $this->render('meritlist', [
        //     'merit' => $data,
        // ]);
	}
    public function actionGetcolleges() {
        $district = $_POST['district'];
        $collegeid = 1;
		$query = new Query;
		$query->select(['collegeid', 'collegename'])
			->from('dhe_legacy_college')
		    ->where('districtid = :districtid', [':districtid' => $district])
            ->andWhere('collegeid <> :collegeid', [':collegeid' => $collegeid])
			->andWhere('collegeid_status = :collegeid_status', [':collegeid_status' => 'ACTIVE'])
			->orderBy([
				'collegename' => SORT_ASC,
			]);
		$command = $query->createCommand();
		$colleges = $command->queryAll();
		
		echo json_encode($colleges) ; die;
	}

    public function actionGetcollegecourse(){
        $collegeid = $_POST['college_id'];
        $select = "select distinct co.name,cc.courseid from dhe_legacy_collegecourse cc inner join dhe_legacy_course co on co.courseid=cc.courseid where
        cc.collegeid='$collegeid' and isactive=1 and cc.sessionid=8 and co.coursemode=3";
        $connection = Yii::$app->db;
        $command = $connection->createCommand($select);
        $rows = $command->queryAll();
        echo json_encode($rows); die;
    }

    public function actionGetcollegecoursesection(){
        $College_ID = $_POST['college_id'];
        $Course_ID = $_POST['course_id'];
        $select = "SELECT (CASE WHEN CAT.id=2 OR CAT.id=3 THEN CONCAT(CS.sectionname,' (',CAT.courseaffiliationtype ,')') ELSE CS.sectionname END ) as sectionname,CC.collegecourseid,CS.coursesectionid 
    from dhe_legacy_collegecourse CC
    inner join dhe_legacy_coursesection CS on CS.coursesectionid = CC.sectionid 
    inner join dhe_legacy_H_CourseAffiliationType CAT on CAT.id = CC.course_affiliation_type
    Where CC.collegeid = ".$College_ID." And CC.isactive = 1 and CC.sessionid = 8 and CS.yearstatus=1 and CC.courseid = ".$Course_ID."
    order by CS.sectionname";
        
        //$select = "select cs.sectionname,cc.collegecourseid from dhe_legacy_collegecourse cc inner join dhe_legacy_coursesection cs on cs.coursesectionid=cc.sectionid
    //    where cc.collegeid=$College_ID and isactive=1 and cc.sessionid=8 and cc.courseid=$Course_ID and cs.yearstatus=1";
        $connection = Yii::$app->db;
        $command = $connection->createCommand($select);
        $rows = $command->queryAll();
        echo json_encode($rows); die;
    }
    
	
}
