<?php

namespace app\modules\admin\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

class StartstopregistrationController extends \yii\web\Controller
{

 	/**
     * @inheritdoc
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'rules' => [
                    [
                        'actions' => ['index','submit','coursewiseonoff','getcourses'],
                        'allow' =>  Yii::$app->utility->isSuperAdmin(),
                    ],
                ],
                'denyCallback' => function ($rule, $action) {
                    if (Yii::$app->utility->isSuperAdmin() === false) {
                        return $action->controller->redirect(BASE_URL.'/site/login');
                    }
                    throw new ForbiddenHttpException("Forbidden access");
                }
            ],

        ];
    }

    public function actionIndex()
    {
		$param=array();

		// Getting Registration Start/Stop Data ::
		$connection = Yii::$app->db;
		$query = "select * from registration_start_stop";
        $model = $connection->createCommand($query);
		$applicationdata = $model->queryOne();

		// Getting Coursetype Data ::
		$querycourse = "select * from coursewise_registration_start_stop";
        $modelcourse = $connection->createCommand($querycourse);
		$coursedata = $modelcourse->queryOne();

		// Getting College Data ::
		$querycollege = "select collegeid,collegename from dhe_legacy_college where collegeid_is_deleted='NO'";
        $modelcollege = $connection->createCommand($querycollege);
		$collegedata = $modelcollege->queryAll();
		//echo "<pre>=="; print_r($collegedata); die();

		if($applicationdata){
			if($applicationdata['registration_start_stop_status']=="ACTIVE"){
				 $param['msg']="Currently Registration is ON";
				 $param['status']=200;
			}
			else{
				 $param['msg']="Currently Registration is stopped";
				 $param['status']=400;
			}
		}

		if($coursedata){
			if($coursedata['course_registration']=='PG'){
				 if($coursedata['course_registration_start_stop_status']=='ACTIVE'){
					  $param['coursemsg']="Currently Post-Graduation registration is ON";
					  $param['coursestatus']=200;
					}
					else{
					  $param['coursemsg']="Currently Post-Graduation registration is OFF";
					  $param['coursestatus']=400;
					}
			}
			else if($coursedata['course_registration']=='UG'){
				if($coursedata['course_registration_start_stop_status']=='ACTIVE'){
				  $param['coursemsg']="Currently Under-Graduation registration is ON";
				  $param['coursestatus']=200;
				}
				else{
				  $param['coursemsg']="Currently Under-Graduation registration is OFF";
				  $param['coursestatus']=400;
				}
			}
			else{
				if($coursedata['course_registration']=='BOTH' && $coursedata['course_registration_start_stop_status']=='ACTIVE'){
				  $param['coursemsg']="Currently UG/PG registration is ON";
				  $param['coursestatus']=200;
				}
				else{
				  $param['coursemsg']="Currently UG/PG registration is OFF";
				  $param['coursestatus']=400;
				}

			}
		}
		//echo "<pre>=="; print_r($param); die();
        return $this->render('index',array('msg'=>$param,'collegedata'=>$collegedata));
    }



	public function actionGetcourses(){

		  $id=$_POST['collegeid'];
		  $dhe_legacy_collegecourse_is_deleted='NO';

		  $sql = "select distinct tab1.courseid from dhe_legacy_collegecourse tab1 inner join dhe_legacy_course tab2
				  on tab1.courseid=tab2.courseid where isactive='1' AND sessionid='4' AND
				  collegeid=$id AND tab1.dhe_legacy_collegecourse_is_deleted='$dhe_legacy_collegecourse_is_deleted'  ";
		  $command = $connection->createCommand($sql);
		  $course_uuid = $command -> queryAll();

		  echo json_encode($course_uuid); die;

	}

    public function actionSubmit()
    {
    	$cnt=0;
    	if(isset($_POST['registration_status'])){
    		$registration_status=$_POST['registration_status'];
    		$connection = Yii::$app->db;
			$update="UPDATE registration_start_stop SET registration_start_stop_status='$registration_status'";
			$command = $connection->createCommand($update);
			$new_row=$command->execute();
    	}

    	$param=array();
		if($new_row){
			if($_POST['registration_status']=='ACTIVE'){
			 $param['msg']="Registration has been started";
			 $param['status']=200;
			}
			else{
			  $param['msg']="Registration has been stopped";
			  $param['status']=400;
			}
		}
		else{
			$param['msg']="Error: try again";
		}
        return $this->render('index',array('msg'=>$param));
    }


	public function actionCoursewiseonoff()
    {
    	$cnt=0;
    	if(isset($_POST['course_registration'])){
    		$course_registration=$_POST['course_registration'];
			$course_registration_status=$_POST['course_registration_status'];
    		$connection = Yii::$app->db;
			$update="UPDATE coursewise_registration_start_stop SET course_registration='$course_registration',course_registration_start_stop_status='$course_registration_status'";
			$command = $connection->createCommand($update);
			$new_row=$command->execute();
    	}

    	$param=array();
		if($new_row){
			if($_POST['course_registration']=='PG'){
			 if($_POST['course_registration_status']=='ACTIVE'){
				  $param['coursemsg']="Under-Graduation registration has been started";
				  $param['coursestatus']=200;
				}
				else{
				  $param['coursemsg']="Under-Graduation registration has been stopped";
				  $param['coursestatus']=400;
				}
			}
			else if($_POST['course_registration']=='UG'){
				if($_POST['course_registration_status']=='ACTIVE'){
				  $param['coursemsg']="Under-Graduation registration has been started";
				  $param['coursestatus']=200;
				}
				else{
				  $param['coursemsg']="Under-Graduation registration has been stopped";
				  $param['coursestatus']=400;
				}
			}
			else{
				if($_POST['course_registration']=='BOTH' && $_POST['course_registration_status']=='ACTIVE'){
				  $param['coursemsg']="UG/PG registration has been started";
				  $param['coursestatus']=200;
				}
				else{
				  $param['coursemsg']="UG/PG registration has been stopped";
				  $param['coursestatus']=400;
				}

			}

		}

		else{
			$param['msg']="Error: try again";
		}

		return $this->render('index',array('msg'=>$param));
    }




}
