<?php

namespace app\modules\api\v1\controllers;

use Yii;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\rest\ActiveController;
use yii\filters\AccessControl;
use yii\web\Response;
use yii\base\ErrorException;
use app\services\JoinSignupService;

class JoinsignupController extends \yii\rest\Controller {
	
	private $rbacInfo=array();
    protected function verbs() {
        return [
            'index' =>  ['GET'],
            'getbyuuid' => ['POST'],
			'create' => ['POST'],
			'login' => ['POST'],
            'update' => ['POST'],
            'delete' => ['POST'],
        ];
    }
    
    public function beforeAction($event) { 
    	// Allow from any origin
	if (isset($_SERVER['HTTP_ORIGIN'])) {
		header("Access-Control-Allow-Origin: {$_SERVER['HTTP_ORIGIN']}");
		header('Access-Control-Allow-Credentials: true');
		header('Access-Control-Max-Age: 86400');    // cache for 1 day
	}

	// Access-Control headers are received during OPTIONS requests
	if ($_SERVER['REQUEST_METHOD'] == 'OPTIONS') {
		if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_METHOD']))
		    header("Access-Control-Allow-Methods: GET, POST, OPTIONS");         

		if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']))
		    header("Access-Control-Allow-Headers:        {$_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']}");

		exit(0);
	}
       $this->enableCsrfValidation = false;
       $headers = Yii::$app->request->headers;
       $method = $event->id; 

       if(!$headers->has('token') && $method!='create' && $method!='login') {
       
       //if(!$headers->has('token')) {
            http_response_code(401);
			$errorMsg="Unauthorized Access";
			$token=Yii::$app->request->headers['token'];
			$class=__FILE__;
			$method=__FUNCTION__;
			$model="JoinSignupService";
		    $message=" ERROR $errorMsg at line ".__LINE__;
			Yii::$app->utility->logError($class,$method,$model,$token,$message);
            echo json_encode(array("error" => $errorMsg));
            exit;
       } 
	   
		else {
			if( Yii::$app->utility->isValidToken(Yii::$app->request->headers['token']) ) {
				$token = Yii::$app->request->headers['token'];
				$this->rbacInfo= Yii::$app->utility->getRBAC($token);
	   		}
           $action = $event->id;
           if (isset($this->actions[$action])) {
               $verbs = $this->actions[$action];
           } elseif (isset($this->actions['*'])) {
               $verbs = $this->actions['*'];
           } else {
               return $event->isValid;
           }
           $verb = Yii::$app->getRequest()->getMethod();       
           $allowed = array_map('strtoupper', $verbs);

           if (!in_array($verb, $allowed)) {
               http_response_code(401);
			    $errorMsg="Method not allowed";
				$token=Yii::$app->request->headers['token'];
				$class=__FILE__;
				$method=__FUNCTION__;
				$model="JoinSignupService";
				$message=" ERROR $errorMsg at line ".__LINE__;
				Yii::$app->utility->logError($class,$method,$model,$token,$message);
               echo json_encode(array("error" => $errorMsg));
               exit;
           }        
           return true;
       }
    } 


    public function actionIndex() {
        
        $join_signup_is_deleted="NO";
        $model = JoinSignupService::find()
                    ->where('join_signup_is_deleted = :join_signup_is_deleted', [':join_signup_is_deleted' => $join_signup_is_deleted])
					->asArray()
				    ->all();
        
        echo json_encode(array("response" => $model));
        exit;
    }

	 public function actionGetbyuuid() {
        
         try {
             //Add JSON Reading capability 
             $JSON=trim(file_get_contents('php://input'));           
             if(!empty($JSON) ){ 
                $_POST = json_decode($JSON,true); //convert JSON into arr   
                switch (json_last_error()) {
                    case JSON_ERROR_NONE:
                        //echo ' - No errors';
                    break;
                    case JSON_ERROR_DEPTH:
                        echo 'JSON ERROR - Maximum stack depth exceeded'; exit;
                    break;
                    case JSON_ERROR_STATE_MISMATCH:
                        echo 'JSON ERROR - Underflow or the modes mismatch'; exit;
                    break;
                    case JSON_ERROR_CTRL_CHAR:
                        echo 'JSON ERROR - Unexpected control character found'; exit;
                    break;
                    case JSON_ERROR_SYNTAX:
                        echo 'JSON ERROR - Syntax error, malformed JSON'; exit;
                    break;
                    case JSON_ERROR_UTF8:
                        echo 'JSON ERROR - Malformed UTF-8 characters, possibly incorrectly encoded'; exit;
                    break;
                    default:
                        echo 'JSON ERROR - Unknown error'; exit;
                    break;
                }         
             }
            
            $join_signup_uuid = $_POST['join_signup_uuid'];

            $model = JoinSignupService::find()
                    ->where('join_signup_uuid = :join_signup_uuid', [':join_signup_uuid' => $join_signup_uuid])
					->one();
            if(!$model){
                echo json_encode(array("error" => "Invalid Method or parameters. Please try again"));
                exit; 
            }          		

			$row= $model->attributes;
            return json_encode(array("response" => $row));        
        
        } 
        catch (ErrorException $e) {
            $errorMsg="Invalid Method. Please try again";
			$token=Yii::$app->request->headers['token'];
			$class=__FILE__;
			$method=__FUNCTION__;
			$model="JoinSignupService";
			$message= $e->getMessage()." ERROR $errorMsg at line ".__LINE__;
			Yii::$app->utility->logException($class,$method,$model,$token,$message);
            echo json_encode(array("error" => $errorMsg));
            exit;
        }
    }

    public function actionCreate() {   
        
        try {
            $model = new JoinSignupService();
            
            if(!$model){
				$errorMsg="Invalid Method or parameters. Please try again";
				$token=Yii::$app->request->headers['token'];
				$class=__FILE__;
				$method=__FUNCTION__;
				$model="JoinSignupService";
				$message=" ERROR $errorMsg at line ".__LINE__;
				Yii::$app->utility->logError($class,$method,$model,$token,$message);
                echo json_encode(array("error" => $errorMsg));
                exit; 
            }
	       
	         //Add JSON Reading capability 
             $JSON=trim(file_get_contents('php://input'));           
             if(!empty($JSON) ){ 
                $_POST = json_decode($JSON,true); //convert JSON into arr   
                switch (json_last_error()) {
                    case JSON_ERROR_NONE:
                        //echo ' - No errors';
                    break;
                    case JSON_ERROR_DEPTH:
                        echo 'JSON ERROR - Maximum stack depth exceeded'; exit;
                    break;
                    case JSON_ERROR_STATE_MISMATCH:
                        echo 'JSON ERROR - Underflow or the modes mismatch'; exit;
                    break;
                    case JSON_ERROR_CTRL_CHAR:
                        echo 'JSON ERROR - Unexpected control character found'; exit;
                    break;
                    case JSON_ERROR_SYNTAX:
                        echo 'JSON ERROR - Syntax error, malformed JSON'; exit;
                    break;
                    case JSON_ERROR_UTF8:
                        echo 'JSON ERROR - Malformed UTF-8 characters, possibly incorrectly encoded'; exit;
                    break;
                    default:
                        echo 'JSON ERROR - Unknown error'; exit;
                    break;
                }         
             }
             
			$moduleName = 'Joinsignup';
            $tableName  = 'JoinSignupService';
            $uuid = Yii::$app->utility->generateGuuid($moduleName,$tableName);
            $_POST['join_signup_uuid'] = $uuid;
            $_POST['join_signup_modified_date'] = date("Y-m-d H:i:s");

            if(isset($_POST['join_signup_password']) && !empty($_POST['join_signup_password']) ){
                $join_signup_password=$_POST['join_signup_password'];
                $options = ['cost' => 12];
                $join_signup_password = password_hash($join_signup_password, PASSWORD_BCRYPT, $options);
                $_POST['join_signup_password'] = $join_signup_password;
            }

            $model->attributes = $_POST;
            if ($model->validate()) {
                $model->save();
                echo json_encode(array("response" => $model));
                exit;
            } else {
                $errors = $model->errors;
                echo json_encode(array("error" => $errors));
                exit;
            }
            
        } 
        catch (ErrorException $e) {
			$errorMsg="Invalid Method. Please try again";
			$token=Yii::$app->request->headers['token'];
			$class=__FILE__;
			$method=__FUNCTION__;
			$model="JoinSignupService";
			$message= $e->getMessage()." ERROR $errorMsg at line ".__LINE__;
			Yii::$app->utility->logException($class,$method,$model,$token,$message);
            echo json_encode(array("error" => $errorMsg));
            exit;
        }
        
    }
    


    public function actionLogin() {   
        
        try {
            $model = new JoinSignupService();
            
            if(!$model){
				$errorMsg="Invalid Method or parameters. Please try again";
				$token=Yii::$app->request->headers['token'];
				$class=__FILE__;
				$method=__FUNCTION__;
				$model="JoinSignupService";
				$message=" ERROR $errorMsg at line ".__LINE__;
				Yii::$app->utility->logError($class,$method,$model,$token,$message);
                echo json_encode(array("error" => $errorMsg));
                exit; 
            }
	       
	         //Add JSON Reading capability 
             $JSON=trim(file_get_contents('php://input'));           
             if(!empty($JSON) ){ 
                $_POST = json_decode($JSON,true); //convert JSON into arr   
                switch (json_last_error()) {
                    case JSON_ERROR_NONE:
                        //echo ' - No errors';
                    break;
                    case JSON_ERROR_DEPTH:
                        echo 'JSON ERROR - Maximum stack depth exceeded'; exit;
                    break;
                    case JSON_ERROR_STATE_MISMATCH:
                        echo 'JSON ERROR - Underflow or the modes mismatch'; exit;
                    break;
                    case JSON_ERROR_CTRL_CHAR:
                        echo 'JSON ERROR - Unexpected control character found'; exit;
                    break;
                    case JSON_ERROR_SYNTAX:
                        echo 'JSON ERROR - Syntax error, malformed JSON'; exit;
                    break;
                    case JSON_ERROR_UTF8:
                        echo 'JSON ERROR - Malformed UTF-8 characters, possibly incorrectly encoded'; exit;
                    break;
                    default:
                        echo 'JSON ERROR - Unknown error'; exit;
                    break;
                }         
             }
             
			$moduleName = 'Joinsignup';
            $tableName  = 'JoinSignupService';
            $uuid = Yii::$app->utility->generateGuuid($moduleName,$tableName);
            $_POST['join_signup_uuid'] = $uuid;
            $_POST['join_signup_modified_date'] = date("Y-m-d H:i:s");
            
            if( isset($_POST['join_signup_email']) &&  !empty($_POST['join_signup_email']) ){
                $join_signup_email=$_POST['join_signup_email'];
                $join_signup_password=$_POST['join_signup_password'];
                 
                $SEL="SELECT * FROM `join_signup`  WHERE join_signup_email  = :join_signup_email
                  AND join_signup_status='ACTIVE' AND join_signup_is_deleted ='NO' LIMIT 1";
                  
                $connection = Yii::$app->db;	
                 
                $command = $connection->createCommand($SEL);
                $command->bindValue(':join_signup_email', $join_signup_email);
                $data = $command->queryOne(); 
                
                $hash = $data['join_signup_password'];
                $join_signup_uuid = $data['join_signup_uuid'];
                //Already login
                $SELECT = "SELECT token FROM `sso_user_token` WHERE user_uuid='$join_signup_uuid' ";            
                $command1 = $connection->createCommand($SELECT);
                $data1 = $command1->queryOne(); 
                
                if(!empty($data1) && isset($data1['token']) ){
                   $response['token']=$data1['token'];
                    echo json_encode(array("response" => $response));
                    exit;                   
                }
                
                //Check Password                
                if (password_verify($join_signup_password, $hash)) {
                    $sso_user_token_modified_date= date("Y-m-d H:i:s");
                    $user_uuid =$join_signup_uuid;
                    $token=md5($join_signup_uuid.time().rand(111111,99999));
                    
                    $sso_user_token_uuid=md5('sso_user_token_uuid'.rand(111111,99999).time());
                    $INSERT="INSERT INTO sso_user_token (sso_user_token_uuid, user_uuid, token, sso_user_token_created_date, sso_user_token_modified_date) 
                            VALUES ('$sso_user_token_uuid', '$user_uuid', '$token', '$sso_user_token_created_date', '$sso_user_token_modified_date') ";
                    
                    $command2 = $connection->createCommand($INSERT);
                    $command2->execute();
                    
                    $response['token']=$token;  
                    echo json_encode(array("response" => $response));
                    exit;  
                }
            }
            
            $errors = 'Invalid username or password. Please try again';
            echo json_encode(array("error" => $errors));
            exit;
            
        } 
        catch (ErrorException $e) {
			$errorMsg="Invalid Method. Please try again";
			$token=Yii::$app->request->headers['token'];
			$class=__FILE__;
			$method=__FUNCTION__;
			$model="JoinSignupService";
			$message= $e->getMessage()." ERROR $errorMsg at line ".__LINE__;
			Yii::$app->utility->logException($class,$method,$model,$token,$message);
            echo json_encode(array("error" => $errorMsg));
            exit;
        }
        
    }    
    

    public function actionUpdate() {
        try {
            $join_signup_uuid = $_POST['join_signup_uuid'];

            $model = JoinSignupService::find()
                    ->where('join_signup_uuid = :join_signup_uuid', [':join_signup_uuid' => $join_signup_uuid])
					->one();
            if(!$model){
                echo json_encode(array("error" => "Invalid Method or parameters. Please try again"));
                exit; 
            }
            
            //Add JSON Reading capability 
             $JSON=trim(file_get_contents('php://input'));           
             if(!empty($JSON) ){ 
                $_POST = json_decode($JSON,true); //convert JSON into arr   
                switch (json_last_error()) {
                    case JSON_ERROR_NONE:
                        //echo ' - No errors';
                    break;
                    case JSON_ERROR_DEPTH:
                        echo 'JSON ERROR - Maximum stack depth exceeded'; exit;
                    break;
                    case JSON_ERROR_STATE_MISMATCH:
                        echo 'JSON ERROR - Underflow or the modes mismatch'; exit;
                    break;
                    case JSON_ERROR_CTRL_CHAR:
                        echo 'JSON ERROR - Unexpected control character found'; exit;
                    break;
                    case JSON_ERROR_SYNTAX:
                        echo 'JSON ERROR - Syntax error, malformed JSON'; exit;
                    break;
                    case JSON_ERROR_UTF8:
                        echo 'JSON ERROR - Malformed UTF-8 characters, possibly incorrectly encoded'; exit;
                    break;
                    default:
                        echo 'JSON ERROR - Unknown error'; exit;
                    break;
                }         
             }

            $model->attributes = $_POST;
            if ($model->validate()) {
                $model->save();				
				$row= $model->attributes;
                return json_encode(array("response" => $row));
                exit;
            } else {
                $errors = $model->errors;
                echo json_encode(array("error" => $errors));
                exit;
            }
            
        } 
        catch (ErrorException $e) {
            $errorMsg="Invalid Method. Please try again";
			$token=Yii::$app->request->headers['token'];
			$class=__FILE__;
			$method=__FUNCTION__;
			$model="JoinSignupService";
			$message= $e->getMessage()." ERROR $errorMsg at line ".__LINE__;
			Yii::$app->utility->logException($class,$method,$model,$token,$message);
            echo json_encode(array("error" => $errorMsg));
            exit;
        }
    }
    
    
    public function actionDelete() {
        try {
            
            //Add JSON Reading capability 
             $JSON=trim(file_get_contents('php://input'));           
             if(!empty($JSON) ){ 
                $_POST = json_decode($JSON,true); //convert JSON into arr   
                switch (json_last_error()) {
                    case JSON_ERROR_NONE:
                        //echo ' - No errors';
                    break;
                    case JSON_ERROR_DEPTH:
                        echo 'JSON ERROR - Maximum stack depth exceeded'; exit;
                    break;
                    case JSON_ERROR_STATE_MISMATCH:
                        echo 'JSON ERROR - Underflow or the modes mismatch'; exit;
                    break;
                    case JSON_ERROR_CTRL_CHAR:
                        echo 'JSON ERROR - Unexpected control character found'; exit;
                    break;
                    case JSON_ERROR_SYNTAX:
                        echo 'JSON ERROR - Syntax error, malformed JSON'; exit;
                    break;
                    case JSON_ERROR_UTF8:
                        echo 'JSON ERROR - Malformed UTF-8 characters, possibly incorrectly encoded'; exit;
                    break;
                    default:
                        echo 'JSON ERROR - Unknown error'; exit;
                    break;
                }         
             }
             
            $join_signup_uuid = $_POST['join_signup_uuid'];

            $model = JoinSignupService::find()
                    ->where('join_signup_uuid = :join_signup_uuid', [':join_signup_uuid' => $join_signup_uuid])
         			->one();
            if(!$model){
                echo json_encode(array("error" => "Invalid Method or parameters. Please try again"));
                exit; 
            }

            $model->join_signup_is_deleted = "YES";
            if ($model->validate()) {
                $model->save();
				$row= $model->attributes;
                echo json_encode(array("response" => $row));
                exit;
            } else {
                $errors = $model->errors;
                echo json_encode(array("error" => $errors));
                exit;
            }
            
        } 
        catch (ErrorException $e) {
            $errorMsg="Invalid Method. Please try again";
			$token=Yii::$app->request->headers['token'];
			$class=__FILE__;
			$method=__FUNCTION__;
			$model="JoinSignupService";
			$message= $e->getMessage()." ERROR $errorMsg at line ".__LINE__;
			Yii::$app->utility->logException($class,$method,$model,$token,$message);
            echo json_encode(array("error" => $errorMsg));
            exit;
        }
    }

}
